# raw – Executes a low-down and dirty command

- Synopsis

- Parameters

- Notes

- See Also

- Examples

- Status

## Synopsis

- Executes a low-down and dirty SSH command, not going through the module subsystem.

- This is useful and should only be done in a few cases. A common case is installing `python` on a system without python installed by default. Another is speaking to any devices such as routers that do not have any Python installed. In any other case, using the shell or command module is much more appropriate.

- Arguments given to `raw` are run directly through the configured remote shell.

- Standard output, error output and return code are returned when available.

- There is no change handler support for this module.

- This module does not require python on the remote system, much like the script module.

- This module is also supported for Windows targets.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
executable - |  | Change the shell used to execute the command. Should be an absolute path to the executable. When using privilege escalation (`become`) a default shell will be assigned if one is not provided as privilege escalation requires a shell.
free_form - / required |  | The raw module takes a free form command to run. There is no parameter actually named 'free form'; see the examples!

## Notes

Note

- If using raw from a playbook, you may need to disable fact gathering using `gather_facts: no` if you’re using `raw` to bootstrap python onto the machine.

- If you want to execute a command securely and predictably, it may be better to use the command or shell modules instead.

- The `environment` keyword does not work with raw normally, it requires a shell which means it only works if `executable` is set or using the module with privilege escalation (`become`).

- This module is also supported for Windows targets.

## See Also

See also

command – Execute commands on targets

  The official documentation on the command module.

shell – Execute shell commands on targets

  The official documentation on the shell module.

win_command – Executes a command on a remote Windows node

  The official documentation on the win_command module.

win_shell – Execute shell commands on target hosts

  The official documentation on the win_shell module.

## Examples

    - name: Bootstrap a host without python2 installed
      raw: dnf install -y python2 python2-dnf libselinux-python

    - name: Run a command that uses non-posix shell-isms (in this example /bin/sh doesn't handle redirection and wildcards together but bash does)
      raw: cat < /tmp/*txt
      args:
        executable: /bin/bash

    - name: Safely use templated variables. Always use quote filter to avoid injection issues.
      raw: "{{ package_mgr|quote }} {{ pkg_flags|quote }} install {{ python|quote }}"

    - name: List user accounts on a Windows system
      raw: Get-WmiObject -Class Win32_UserAccount

## Status

- This module is guaranteed to have backward compatible interface changes going forward. [stableinterface]

- This module is maintained by the Ansible Core Team. [core]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Ansible Core Team

- Michael DeHaan

Hint

If you notice any issues in this documentation, you can edit this document to improve it.